classification
Title: Make support.threading_cleanup() stricter
Type: Stage: patch review
Components: Tests Versions: Python 3.7
process
Status: open Resolution:
Dependencies: Superseder:
Assigned To: Nosy List: haypo
Priority: normal Keywords: patch

Created on 2017-08-18 17:12 by haypo, last changed 2017-09-15 23:55 by haypo.

Pull Requests
URL Status Linked Edit
PR 3138 merged haypo, 2017-08-18 17:15
PR 3139 merged haypo, 2017-08-18 17:17
PR 3150 merged haypo, 2017-08-18 23:32
PR 3152 merged haypo, 2017-08-18 23:55
PR 3187 merged haypo, 2017-08-22 15:35
PR 3188 merged haypo, 2017-08-22 15:46
PR 3189 merged haypo, 2017-08-22 15:50
PR 3516 merged haypo, 2017-09-12 17:25
PR 3519 merged python-dev, 2017-09-12 17:49
PR 3535 merged haypo, 2017-09-13 09:42
PR 3536 merged python-dev, 2017-09-13 09:49
PR 3537 merged python-dev, 2017-09-13 09:51
PR 3540 merged haypo, 2017-09-13 10:35
PR 3544 merged haypo, 2017-09-13 13:22
PR 3546 merged haypo, 2017-09-13 16:06
PR 3552 merged python-dev, 2017-09-13 20:43
PR 3554 merged haypo, 2017-09-13 20:49
PR 3557 merged haypo, 2017-09-13 23:08
PR 3572 merged haypo, 2017-09-14 15:06
PR 3573 merged haypo, 2017-09-14 15:12
PR 3578 merged haypo, 2017-09-14 16:42
PR 3579 merged haypo, 2017-09-14 16:56
PR 3586 merged haypo, 2017-09-14 20:40
PR 3587 merged haypo, 2017-09-14 21:27
PR 3589 merged haypo, 2017-09-14 21:48
PR 3598 merged haypo, 2017-09-15 12:20
PR 3599 merged haypo, 2017-09-15 12:40
Messages (48)
msg300519 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-08-18 17:12
Currently, support.threading_cleanup() waits 1 second before emitting a warning about threads running in the background. I propose to emit immediately the warning to be able to catch bugs quicker, bugs like bpo-31233 or bpo-30830.

The problem is that currently, 12 test files still leak threads:
---
12 tests altered the execution environment:
    test_asyncio test_concurrent_futures test_fork1 test_httpservers
    test_logging test_pydoc test_ssl test_thread test_threaded_import
    test_threading test_wait3 test_xmlrpc
---

Since threading_cleanup() warnings now mark tests as failed, we should first fix these tests before being able to make support.threading_cleanup() stricter.
msg300520 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-08-18 17:19
test_fork1, test_wait3: https://github.com/python/cpython/pull/3139
msg300531 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-08-18 21:12
New changeset c99d41f9c0304fcf06550515c3db55f93a629e9e by Victor Stinner in branch 'master':
bpo-31234: fork_wait tests now join threads (#3139)
https://github.com/python/cpython/commit/c99d41f9c0304fcf06550515c3db55f93a629e9e
msg300553 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-08-18 23:32
test_threading: https://github.com/python/cpython/pull/3150
msg300558 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-08-18 23:53
test_pydoc: see bpo-31238.
msg300559 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-08-18 23:54
test_logging: see bpo-30830.
msg300560 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-08-18 23:54
New changeset 3d284c081fc3042036adfe1bf2ce92c34d743b0b by Victor Stinner in branch 'master':
bpo-31234: test_threading: fix ref cycle (#3150)
https://github.com/python/cpython/commit/3d284c081fc3042036adfe1bf2ce92c34d743b0b
msg300561 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-08-19 00:32
New changeset b50e7683acac36ff16e6c6c2c32d9a15e46b5174 by Victor Stinner in branch '3.6':
bpo-31234: test_threading: fix ref cycle (#3150) (#3152)
https://github.com/python/cpython/commit/b50e7683acac36ff16e6c6c2c32d9a15e46b5174
msg300631 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-08-21 15:53
test_xmlrpc: bpo-31247, "test_xmlrpc leaks dangling threads".
msg300636 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-08-21 16:16
test_concurrent_futures: bpo-31249, test_concurrent_futures leaks dangling threads.
msg300638 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-08-21 16:34
test_asyncio: bpo-31250, "test_asyncio leaks dangling threads".
msg300706 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-08-22 16:03
New changeset 5f20539ee5c6e3f1da23e8fc31ba519a3d078c79 by Victor Stinner in branch '3.6':
bpo-31234: fork_wait tests now join threads (#3139) (#3187)
https://github.com/python/cpython/commit/5f20539ee5c6e3f1da23e8fc31ba519a3d078c79
msg300708 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-08-22 16:05
New changeset 830d7d2936434ace113822294acce82f62cde41b by Victor Stinner in branch 'master':
bpo-31234: test_httpservers joins the server thread (#3188)
https://github.com/python/cpython/commit/830d7d2936434ace113822294acce82f62cde41b
msg300709 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-08-22 16:05
New changeset 41bbd82b6b6a887e893974fa5cdaae7782ae6cac by Victor Stinner in branch 'master':
bpo-31234: test_threaded_import: fix test_side_effect_import() (#3189)
https://github.com/python/cpython/commit/41bbd82b6b6a887e893974fa5cdaae7782ae6cac
msg301118 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-01 15:01
test_ssl still emits a warning: see bpo-31323.
msg301132 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-01 16:00
Remaining issues:

* test_asyncio: https://github.com/python/cpython/pull/3264 of bpo-31250

* test_thread: test_forkinthread() spawns a thread using thread.start_new_thread() without waiting until the thread completes

* test_concurrent_futures: warnings raised when running "./python -u -m test -j0 -rW -u all --fail-env-changed", but not when running only test_concurrent_futures. It looks like a race condition.
msg301982 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-12 17:49
New changeset a15d155aadfad232158f530278505cdc6f326f93 by Victor Stinner in branch 'master':
bpo-31234: Enhance test_thread.test_forkinthread() (#3516)
https://github.com/python/cpython/commit/a15d155aadfad232158f530278505cdc6f326f93
msg302005 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-12 23:14
New changeset bcf042ff98b6261b7780c1e40fa1681ef30502f9 by Victor Stinner (Miss Islington (bot)) in branch '3.6':
[3.6] bpo-31234: Enhance test_thread.test_forkinthread() (GH-3516) (#3519)
https://github.com/python/cpython/commit/bcf042ff98b6261b7780c1e40fa1681ef30502f9
msg302008 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-13 00:04
Remaining issue: socketserver. bpo-31233: socketserver.ThreadingMixIn leaks running threads after server_close()

See also bpo-31151: socketserver.ForkingMixIn.server_close() leaks zombie processes.
msg302048 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-13 10:04
I rebased PR 3138: 3 tests failed on Travis CI.

test_ssl:

Warning -- threading_cleanup() failed to cleanup 0 threads (count: 0, dangling: 3)
Dangling thread: <HTTPSServerThread(Thread-209, stopped daemon 47903503230720)>
Dangling thread: <ThreadedEchoServer(Thread-173, stopped daemon 47903503230720)>
Dangling thread: <_MainThread(MainThread, started 47903383548928)>

test_poplib:

Warning -- threading_cleanup() failed to cleanup 0 threads (count: 0, dangling: 3)
Dangling thread: <test.test_poplib.DummyPOP3Server localhost:0 at 0x2b42fe691a80>
Dangling thread: <_MainThread(MainThread, started 47566631539712)>
Dangling thread: <test.test_poplib.DummyPOP3Server localhost:0 at 0x2b42fe6addc0>
/home/travis/build/python/cpython/Lib/test/support/__init__.py:1511: ResourceWarning: unclosed <socket.socket [closed] fd=5, family=AddressFamily.AF_INET, type=2049, proto=6>
  gc.collect()
/home/travis/build/python/cpython/Lib/test/support/__init__.py:1511: ResourceWarning: unclosed <socket.socket [closed] fd=6, family=AddressFamily.AF_INET, type=SocketKind.SOCK_STREAM, proto=6>
  gc.collect()
/home/travis/build/python/cpython/Lib/test/support/__init__.py:1511: ResourceWarning: unclosed <socket.socket [closed] fd=7, family=AddressFamily.AF_INET, type=2049, proto=6>
  gc.collect()

test_ftplib:

Warning -- threading_cleanup() failed to cleanup 0 threads (count: 0, dangling: 4)
Dangling thread: <test.test_ftplib.DummyTLS_FTPServer localhost:0 at 0x2b72275b4128>
Dangling thread: <test.test_ftplib.DummyTLS_FTPServer localhost:0 at 0x2b72279cb538>
Dangling thread: <Thread(Thread-41, stopped 47769290839808)>
Dangling thread: <_MainThread(MainThread, started 47769182004224)>
msg302053 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-13 10:26
New changeset 42f7e0d8b0ca940a809a786f25d967dcce4d71b6 by Victor Stinner in branch '2.7':
bpo-31234: fork_wait tests now join threads (#3139) (#3535)
https://github.com/python/cpython/commit/42f7e0d8b0ca940a809a786f25d967dcce4d71b6
msg302055 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-13 10:27
New changeset 89bfc9b0d9033f7c9f086c7281a31a489fe1136f by Victor Stinner (Miss Islington (bot)) in branch '3.6':
[3.6] bpo-31234: test_threaded_import: fix test_side_effect_import() (GH-3189) (#3537)
https://github.com/python/cpython/commit/89bfc9b0d9033f7c9f086c7281a31a489fe1136f
msg302056 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-13 10:27
New changeset 6c25b73194714e78975eddea3799f06f3de74647 by Victor Stinner (Miss Islington (bot)) in branch '3.6':
[3.6] bpo-31234: test_httpservers joins the server thread (GH-3188) (#3536)
https://github.com/python/cpython/commit/6c25b73194714e78975eddea3799f06f3de74647
msg302058 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-13 10:58
New changeset d403a29c0055de6b03ed5ae7a5c564e1c95a5950 by Victor Stinner in branch 'master':
bpo-31234: Fix dangling thread in test_ftp/poplib (#3540)
https://github.com/python/cpython/commit/d403a29c0055de6b03ed5ae7a5c564e1c95a5950
msg302076 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-13 13:44
New changeset b157ce1e58b03988ce4340a55d0b856125833cc5 by Victor Stinner in branch 'master':
bpo-31234: Fix dangling thread in test_ftplib (#3544)
https://github.com/python/cpython/commit/b157ce1e58b03988ce4340a55d0b856125833cc5
msg302078 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-13 14:11
test_ssl:

test_recv_zero (test.test_ssl.ThreadedTests) ...  server:  new connection from ('127.0.0.1', 54502)
 server: connection cipher is now ('ECDHE-RSA-AES256-SHA', 'TLSv1/SSLv3', 256)
 server: selected protocol is now None
Warning -- threading_cleanup() failed to cleanup 0 threads (count: 0, dangling: 2)
Dangling thread: <_MainThread(MainThread, started 47577226880000)>
Dangling thread: <ThreadedEchoServer(Thread-173, stopped daemon 47577348138752)>
ok

test_socketserver (test.test_ssl.ThreadedTests)
(...)
stopping HTTPS server
joining HTTPS thread
Warning -- threading_cleanup() failed to cleanup 0 threads (count: 0, dangling: 2)
Dangling thread: <HTTPSServerThread(Thread-209, stopped daemon 47577348138752)>
Dangling thread: <_MainThread(MainThread, started 47577226880000)>
ok
msg302098 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-13 17:10
New changeset acb9fa79fa6453c2bbe3ccfc9cad2837feb90093 by Victor Stinner in branch 'master':
bpo-31234, socket.create_connection(): Fix ref cycle (#3546)
https://github.com/python/cpython/commit/acb9fa79fa6453c2bbe3ccfc9cad2837feb90093
msg302112 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-13 20:42
New changeset ace1ecc00b35a8b1dc6e352d547dde07913017bb by Victor Stinner in branch 'master':
bpo-31234: threading_cleanup() now warns immediately (#3138)
https://github.com/python/cpython/commit/ace1ecc00b35a8b1dc6e352d547dde07913017bb
msg302115 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-13 21:02
Hum, test_barrier of test_thread failed:

http://buildbot.python.org/all/builders/AMD64%20FreeBSD%2010.x%20Shared%203.x/builds/880/steps/test/logs/stdio

0:02:09 load avg: 2.50 [106/405/1] test_thread failed (env changed) -- running: test_multiprocessing_spawn (63 sec), test_multiprocessing_forkserver (54 sec)

test_barrier (test.test_thread.BarrierTest) ...
(...)
task 8 leaving barrier
task 2 leaving barrier
task 9 leaving barrier
tasks done
Warning -- threading_cleanup() failed to cleanup 1 threads (count: 1, dangling: 1)
Dangling thread: <_MainThread(MainThread, started 34393318400)>
ok
msg302122 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-13 21:41
Source_ModuleLockAsRLockTests.test_different_thread() of test.test_importlib.test_locks failed:

http://buildbot.python.org/all/builders/x86-64%20El%20Capitan%203.x/builds/758/steps/test/logs/stdio

test_different_thread (test.test_importlib.test_locks.Source_ModuleLockAsRLockTests) ... Warning -- threading_cleanup() failed to cleanup 1 threads (count: 1, dangling: 1)
Dangling thread: <_MainThread(MainThread, started 140735235059712)>
ok
msg302128 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-13 22:54
New changeset d99e85b9f6422dd5e4f2eb1539368fc4003d4c8b by Victor Stinner (Miss Islington (bot)) in branch '3.6':
[3.6] bpo-31234, socket.create_connection(): Fix ref cycle (GH-3546) (#3552)
https://github.com/python/cpython/commit/d99e85b9f6422dd5e4f2eb1539368fc4003d4c8b
msg302129 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-13 22:56
New changeset ef323e8d82b07d4e7e4303c360dc32d3de0b3147 by Victor Stinner in branch '3.6':
[3.6] bpo-31234: Fix dangling thread in test_ftp/poplib (#3554)
https://github.com/python/cpython/commit/ef323e8d82b07d4e7e4303c360dc32d3de0b3147
msg302132 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-13 23:41
New changeset 096ae3373abac2c8b3a26a3fe33cc8bd4cbccd4e by Victor Stinner in branch 'master':
bpo-31234: Try to fix lock_tests warning (#3557)
https://github.com/python/cpython/commit/096ae3373abac2c8b3a26a3fe33cc8bd4cbccd4e
msg302150 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-14 07:25
test_threading.test_foreign_thread() failed:

http://buildbot.python.org/all/builders/AMD64%20FreeBSD%20CURRENT%20Debug%203.x/builds/879/steps/test/logs/stdio

0:08:53 load avg: 1.84 [286/405/1] test_threading failed (env changed) -- running: test_multiprocessing_spawn (51 sec)
(...)
test_dummy_thread_after_fork (test.test_threading.ThreadTests) ... ok
test_enumerate_after_join (test.test_threading.ThreadTests) ... ok
test_finalize_runnning_thread (test.test_threading.ThreadTests) ... ok
test_finalize_with_trace (test.test_threading.ThreadTests) ... ok
test_foreign_thread (test.test_threading.ThreadTests) ... Warning -- threading_cleanup() failed to cleanup 1 threads (count: 1, dangling: 1)
Dangling thread: <_MainThread(MainThread, started 34369060864)>
ok
test_frame_tstate_tracing (test.test_threading.ThreadTests) ... ok
msg302151 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-14 07:27
3 more warnings in test_threading on AMD64 FreeBSD 10.x Shared 3.x:

http://buildbot.python.org/all/builders/AMD64%20FreeBSD%2010.x%20Shared%203.x/builds/886/steps/test/logs/stdio

0:03:45 load avg: 4.05 [246/405/1] test_thread failed (env changed)
(...)
test_nt_and_posix_stack_size (test.test_thread.ThreadRunningTests) ... (...)
task 4 done
task 10 done
all tasks done
Warning -- threading_cleanup() failed to cleanup 1 threads (count: 1, dangling: 1)
Dangling thread: <_MainThread(MainThread, started 34393318400)>
ok
(...)
test_starting_threads (test.test_thread.ThreadRunningTests) ...
(...)
task 9 will run for 55us
task 9 done
all tasks done
Warning -- threading_cleanup() failed to cleanup 1 threads (count: 1, dangling: 1)
Dangling thread: <_MainThread(MainThread, started 34393318400)>
ok


http://buildbot.python.org/all/builders/AMD64%20FreeBSD%2010.x%20Shared%203.x/builds/884/steps/test/logs/stdio

0:05:44 load avg: 3.00 [249/405/1] test_thread failed (env changed) -- running: test_concurrent_futures (31 sec), test_multiprocessing_fork (60 sec)
test_barrier (test.test_thread.BarrierTest) ...
(...)
task 5 leaving barrier
task 3 leaving barrier
tasks done
Warning -- threading_cleanup() failed to cleanup 1 threads (count: 1, dangling: 1)
Dangling thread: <_MainThread(MainThread, started 34393318400)>
ok
msg302152 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-14 07:29
http://buildbot.python.org/all/builders/AMD64%20FreeBSD%20CURRENT%20Non-Debug%203.x/builds/881/steps/test/logs/stdio

0:08:05 load avg: 1.58 [288/405/1] test_threading failed (env changed) -- running: test_multiprocessing_spawn (83 sec)
(...)
test_dummy_thread_after_fork (test.test_threading.ThreadTests) ... ok
test_enumerate_after_join (test.test_threading.ThreadTests) ... ok
test_finalize_runnning_thread (test.test_threading.ThreadTests) ... ok
test_finalize_with_trace (test.test_threading.ThreadTests) ... ok
test_foreign_thread (test.test_threading.ThreadTests) ...

Warning -- threading_cleanup() failed to cleanup 1 threads (count: 1, dangling: 1)
Dangling thread: <_MainThread(MainThread, started 34368585728)>

ok
test_frame_tstate_tracing (test.test_threading.ThreadTests) ... ok
test_ident_of_no_threading_threads (test.test_threading.ThreadTests) ... ok
msg302163 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-14 09:59
Oh, test_concurrent_futures.test_exception_with_success() failed on Travis CI :-(

https://ci.appveyor.com/project/python/cpython/build/3.7.0a0.6457

test_exception_with_success (test.test_concurrent_futures.FutureTests) ... Warning -- threading_cleanup() failed to cleanup 1 threads (count: 1, dangling: 2)
Dangling thread: <Thread(Thread-1, started 4012)>
Dangling thread: <_MainThread(MainThread, started 3656)>
ok
msg302177 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-14 15:43
New changeset 18e95b4176256f100429a806d0455406df98f984 by Victor Stinner in branch 'master':
bpo-31234: Join threads in tests (#3572)
https://github.com/python/cpython/commit/18e95b4176256f100429a806d0455406df98f984
msg302178 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-14 15:43
New changeset 8dcf22f442320e4c1a5408e67b4c9002ad105f17 by Victor Stinner in branch 'master':
bpo-31234: Join threads in test_hashlib (#3573)
https://github.com/python/cpython/commit/8dcf22f442320e4c1a5408e67b4c9002ad105f17
msg302206 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-14 20:05
New changeset b8c7be2c523b012e57915182543d06657161057f by Victor Stinner in branch 'master':
bpo-31234: Join threads in test_threading (#3579)
https://github.com/python/cpython/commit/b8c7be2c523b012e57915182543d06657161057f
msg302207 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-14 20:07
New changeset ff40ecda73178dfcad24e26240d684356ef20793 by Victor Stinner in branch 'master':
bpo-31234: Add test.support.wait_threads_exit() (#3578)
https://github.com/python/cpython/commit/ff40ecda73178dfcad24e26240d684356ef20793
msg302210 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-14 21:04
New changeset 167cbde50a88ec2a7d26b2cb9891d5e32bdfbfb5 by Victor Stinner in branch 'master':
bpo-31234: Join threads in test_queue (#3586)
https://github.com/python/cpython/commit/167cbde50a88ec2a7d26b2cb9891d5e32bdfbfb5
msg302214 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-14 21:40
New changeset b9b69003d91c6ea94b890ce24ed25686d30f1428 by Victor Stinner in branch 'master':
bpo-31234: Add support.join_thread() helper (#3587)
https://github.com/python/cpython/commit/b9b69003d91c6ea94b890ce24ed25686d30f1428
msg302245 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-15 11:46
Buildbots want my death :-( They never stop failing. Yet another random warning considered as an error:

http://buildbot.python.org/all/builders/AMD64%20FreeBSD%20CURRENT%20Non-Debug%203.x/builds/896/steps/test/logs/stdio

Run tests in parallel using 2 child processes
(...)
0:07:33 load avg: 1.17 [285/405/1] test_threading failed (env changed)
(...)
test_init_immutable_default_args (test.test_threading.TimerTests) ... Warning -- threading_cleanup() failed to cleanup 1 threads (count: 1, dangling: 2)
Dangling thread: <Timer(Thread-261, started 34397998592)>
Dangling thread: <_MainThread(MainThread, started 34368581632)>
ok
msg302247 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-15 12:37
New changeset da3e5cf961f9bcc4bb376386cfe7a2865325086c by Victor Stinner in branch 'master':
bpo-31234: Join timers in test_threading (#3598)
https://github.com/python/cpython/commit/da3e5cf961f9bcc4bb376386cfe7a2865325086c
msg302248 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-15 12:39
Oh, one change of the commit b9b69003d91c6ea94b890ce24ed25686d30f1428 introduced a regression x86 Gentoo Refleaks 3.x. It seems like 5 seconds is not enough on this slow buildbot.

http://buildbot.python.org/all/builders/x86%20Gentoo%20Refleaks%203.x/builds/93/steps/test/logs/stdio

2:28:30 load avg: 6.98 [263/405/1] test_multiprocessing_spawn failed -- running: test_zipfile (797 sec)
beginning 6 repetitions
123456
.Process Process-555:1:1:
Traceback (most recent call last):
  File "/buildbot/buildarea/3.x.ware-gentoo-x86.refleak/build/Lib/multiprocessing/process.py", line 297, in _bootstrap
    self.run()
  File "/buildbot/buildarea/3.x.ware-gentoo-x86.refleak/build/Lib/multiprocessing/process.py", line 99, in run
    self._target(*self._args, **self._kwargs)
  File "/buildbot/buildarea/3.x.ware-gentoo-x86.refleak/build/Lib/test/_test_multiprocessing.py", line 4050, in child
    join_process(p, timeout=5)
  File "/buildbot/buildarea/3.x.ware-gentoo-x86.refleak/build/Lib/test/_test_multiprocessing.py", line 79, in join_process
    support.join_thread(process, timeout)
  File "/buildbot/buildarea/3.x.ware-gentoo-x86.refleak/build/Lib/test/support/__init__.py", line 2117, in join_thread
    raise AssertionError(msg)
AssertionError: failed to join the thread in 5.0 seconds
msg302255 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-15 13:55
New changeset 11f0807a407551d498bb6bd8cc932636f75f1cd7 by Victor Stinner in branch 'master':
bpo-31234: test_multiprocessing: wait 30 seconds (#3599)
https://github.com/python/cpython/commit/11f0807a407551d498bb6bd8cc932636f75f1cd7
msg302305 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-09-15 23:55
New changeset 2c1c2ca2548f943d6323859f17612aa5a4a19165 by Victor Stinner in branch '3.6':
[3.6] bpo-31234: Join threads in tests (#3589)
https://github.com/python/cpython/commit/2c1c2ca2548f943d6323859f17612aa5a4a19165
History
Date User Action Args
2017-09-15 23:55:53hayposetmessages: + msg302305
2017-09-15 13:55:33hayposetmessages: + msg302255
2017-09-15 12:40:19hayposetpull_requests: + pull_request3591
2017-09-15 12:39:30hayposetmessages: + msg302248
2017-09-15 12:37:44hayposetmessages: + msg302247
2017-09-15 12:20:22hayposetpull_requests: + pull_request3590
2017-09-15 11:46:27hayposetmessages: + msg302245
2017-09-14 21:48:10hayposetpull_requests: + pull_request3580
2017-09-14 21:40:58hayposetmessages: + msg302214
2017-09-14 21:27:29hayposetpull_requests: + pull_request3578
2017-09-14 21:04:58hayposetmessages: + msg302210
2017-09-14 20:40:54hayposetpull_requests: + pull_request3577
2017-09-14 20:07:26hayposetmessages: + msg302207
2017-09-14 20:05:23hayposetmessages: + msg302206
2017-09-14 16:56:21hayposetpull_requests: + pull_request3569
2017-09-14 16:42:27hayposetpull_requests: + pull_request3568
2017-09-14 15:43:24hayposetmessages: + msg302178
2017-09-14 15:43:09hayposetmessages: + msg302177
2017-09-14 15:12:18hayposetpull_requests: + pull_request3564
2017-09-14 15:06:48hayposetpull_requests: + pull_request3562
2017-09-14 09:59:32hayposetmessages: + msg302163
2017-09-14 07:29:01hayposetmessages: + msg302152
2017-09-14 07:27:47hayposetmessages: + msg302151
2017-09-14 07:25:08hayposetmessages: + msg302150
2017-09-13 23:41:13hayposetmessages: + msg302132
2017-09-13 23:08:53hayposetpull_requests: + pull_request3549
2017-09-13 22:56:16hayposetmessages: + msg302129
2017-09-13 22:54:38hayposetmessages: + msg302128
2017-09-13 21:41:03hayposetmessages: + msg302122
2017-09-13 21:02:08hayposetmessages: + msg302115
2017-09-13 20:49:03hayposetpull_requests: + pull_request3546
2017-09-13 20:43:07python-devsetpull_requests: + pull_request3545
2017-09-13 20:42:02hayposetmessages: + msg302112
2017-09-13 17:10:12hayposetmessages: + msg302098
2017-09-13 16:06:28hayposetpull_requests: + pull_request3539
2017-09-13 14:11:03hayposetmessages: + msg302078
2017-09-13 13:44:00hayposetmessages: + msg302076
2017-09-13 13:22:39hayposetpull_requests: + pull_request3538
2017-09-13 10:58:27hayposetmessages: + msg302058
2017-09-13 10:35:16hayposetpull_requests: + pull_request3535
2017-09-13 10:27:56hayposetmessages: + msg302056
2017-09-13 10:27:47hayposetmessages: + msg302055
2017-09-13 10:26:56hayposetmessages: + msg302053
2017-09-13 10:04:08hayposetmessages: + msg302048
2017-09-13 09:51:18python-devsetpull_requests: + pull_request3532
2017-09-13 09:49:18python-devsetpull_requests: + pull_request3531
2017-09-13 09:42:50hayposetpull_requests: + pull_request3530
2017-09-13 00:04:03hayposetmessages: + msg302008
2017-09-12 23:14:11hayposetmessages: + msg302005
2017-09-12 17:49:49python-devsetpull_requests: + pull_request3515
2017-09-12 17:49:25hayposetmessages: + msg301982
2017-09-12 17:25:36hayposetkeywords: + patch
stage: patch review
pull_requests: + pull_request3510
2017-09-01 16:00:26hayposetmessages: + msg301132
2017-09-01 15:01:59hayposetmessages: + msg301118
2017-08-22 16:05:34hayposetmessages: + msg300709
2017-08-22 16:05:09hayposetmessages: + msg300708
2017-08-22 16:03:07hayposetmessages: + msg300706
2017-08-22 15:50:36hayposetpull_requests: + pull_request3228
2017-08-22 15:46:23hayposetpull_requests: + pull_request3227
2017-08-22 15:35:50hayposetpull_requests: + pull_request3226
2017-08-21 16:34:16hayposetmessages: + msg300638
2017-08-21 16:16:22hayposetmessages: + msg300636
2017-08-21 15:53:22hayposetmessages: + msg300631
2017-08-19 00:32:57hayposetmessages: + msg300561
2017-08-18 23:55:29hayposetpull_requests: + pull_request3186
2017-08-18 23:54:44hayposetmessages: + msg300560
2017-08-18 23:54:21hayposetmessages: + msg300559
2017-08-18 23:53:09hayposetmessages: + msg300558
2017-08-18 23:32:40hayposetmessages: + msg300553
2017-08-18 23:32:23hayposetpull_requests: + pull_request3184
2017-08-18 21:12:31hayposetmessages: + msg300531
2017-08-18 17:19:13hayposetmessages: + msg300520
2017-08-18 17:17:57hayposetpull_requests: + pull_request3173
2017-08-18 17:15:25hayposetpull_requests: + pull_request3172
2017-08-18 17:12:58haypocreate